'use strict';

const mockingServer = require('mockingjay-npm-wrapper');

describe('mockingJayDemo test', function () {

  describe('scenario - hello', function () {
    beforeAll(mockingServer.serve('stubs/scenario-hello.yml'));
    afterAll(mockingServer.kill());

    it('should receive the hello message from the mocking server', function () {
      browser.get('http://localhost:8080');

      var result = element(by.id('result'));

      expect(result.getText()).toEqual('hello');
    });
  });


  describe('scenario - goodbye', function () {
    beforeAll(mockingServer.serve('stubs/scenario-goodbye.yml'));
    afterAll(mockingServer.kill());

    it('should receive the goodbye message from the mocking server', function () {
      browser.get('http://localhost:8080');

      var result = element(by.id('result'));

      expect(result.getText()).toEqual('goodbye');
    });
  });



});