'use strict';

const child_process = require('child_process')
const fs = require('fs');

const binaries = {
  'darwin': 'darwin_amd64_mockingjay-server-1.10.4',
  'linux': 'linux_amd64_mockingjay-server-1.10.4',
};

if (!binaries[process.platform]) {
  new Error(`Not supported platform: ${process.platform}`);;
}

const binary = __dirname + '/binaries/' + binaries[process.platform];
fs.chmodSync(binary, 111);


let proc = null;

module.exports = {
  serve: (testFile, port = 8000) => {
    return () => {
      if (proc !== null) {
        throw new Error('You have to kill the server to start a new one')
      }
      proc = child_process.spawn(binary,
        [`-config=${testFile}`, `-port=${port}`]);

      proc.stdout.on('data', (data) => {
        console.log(`mocking-jay: ${data}`);
      });

      proc.stderr.on('data', (data) => {
        console.log(`mocking-jay: ${data}`);
      });

      proc.on('close', (code) => {
        console.log(`mocking-jay: exited with code ${code}`);
      });
    }
  },
  kill: () => {
    return () => {
      proc.kill('SIGINT');
      proc = null;
    }
  },
}

